%define	desktop_vendor	anjuta
%define	name		anjuta
%define	version		1.2.2
%define	release		1
%define	serial		1

Summary:	GNOME IDE for C and C++
Name:		%{name}
Version:	%{version}
Release:	%{release}
Serial:		%{serial}
Copyright:	GPL2
Group:		Development/Tools
URL:		http://anjuta.org/
Vendor:		Naba Kumar  <naba@gnome.org>
Source:		%{name}-%{version}.tar.gz
BuildRoot:	/var/tmp/%{name}-%{version}
Docdir:		%{_docdir}

Requires: 	glib2 >= 2.0.6
Requires: 	gtk2 >= 2.0.8
Requires: 	ORBit2 >= 2.4.0
Requires: 	libglade2 >= 2.0.0
Requires: 	libgnome >= 2.0.2
Requires: 	libgnomeui >= 2.0.2
Requires: 	libgnomeprint22 >= 2.0.1
Requires: 	libgnomeprintui22 >= 2.0.1
Requires: 	gnome-vfs2 >= 2.0.2
Requires: 	libbonobo >= 2.0.0
Requires: 	libbonoboui >= 2.0.1
Requires: 	vte >= 0.7.0
Requires: 	libxml2 >= 2.4.23
Requires: 	pango >= 1.1.1
Requires: 	pcre >= 3.9

BuildRequires: 	glib2-devel >= 2.0.6
BuildRequires: 	gtk2-devel >= 2.0.8
BuildRequires: 	ORBit2-devel >= 2.4.0
BuildRequires: 	libglade2-devel >= 2.0.0
BuildRequires: 	libgnome-devel >= 2.0.2
BuildRequires: 	libgnomeui-devel >= 2.0.2
BuildRequires: 	libgnomeprint22-devel >= 2.0.1
BuildRequires: 	libgnomeprintui22-devel >= 2.0.1
BuildRequires: 	gnome-vfs2-devel >= 2.0.2
BuildRequires: 	libbonobo-devel >= 2.0.0
BuildRequires: 	libbonoboui-devel >= 2.0.1
BuildRequires: 	vte-devel >= 0.7.0
BuildRequires: 	libxml2-devel >= 2.4.23
BuildRequires: 	pango-devel >= 1.1.1
BuildRequires: 	pcre-devel >= 3.9

Distribution:	Any
Packager:	Naba Kumar  <naba@gnome.org>

%description
Anjuta is a versatile Integrated Development Environment (IDE) for C and C++. 
It has been written for GTK/GNOME, and features a number of advanced 
programming facilities. It is basically a GUI interface for the collection 
of command line programming utilities and tools available for the GNU system. 
These are usually run via a text console, and can be unfriendly to use.

%package docs
Summary: Anjuta docuemntations package.
Group: Development/Tools

%description docs
Anjuta documentations.

%prep
%setup -q

%build
%configure --enable-final                                                       
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
%makeinstall
rm -fr %{buildroot}/var/scrollkeeper

%clean
rm -rf %{buildroot}

%post docs
if which scrollkeeper-update>/dev/null 2>&1; then scrollkeeper-update; fi

%postun docs
if which scrollkeeper-update>/dev/null 2>&1; then scrollkeeper-update; fi

%files
%defattr(-,root,root)
%doc AUTHORS COPYING ChangeLog INSTALL NEWS README TODO
%doc doc/ScintillaDoc.html

%defattr(-,root,root)
%{_bindir}/%{name}*
%{_libdir}/%{name}
%{_datadir}/%{name}
%{_datadir}/applications/*%{name}.desktop
%{_datadir}/pixmaps/%{name}
%{_datadir}/doc/%{name}
%{_datadir}/mime-info/anjuta.mime
%{_datadir}/mimelnk/application/x-anjuta-project.desktop
%{_datadir}/locale
%{_mandir}/man1/*

%files docs
%defattr(-, root, root)
%{_datadir}/gnome/help/%{name}
%{_datadir}/omf/%{name}
